import QtQuick 2.9
import QtQuick.Controls 2.2
import QtQuick.Layouts 1.0

Page {
    id: page
    width: 600
    height: 400
    property alias txtPort: txtPort
    property alias textFieldPort: textFieldPort
    property alias btBroadcast: btBroadcast
    property alias textFieldIP: textFieldIP

    header: Label {
        text: qsTr("Configuració per a l'ESP8266")
        font.pixelSize: Qt.application.font.pixelSize * 2
        padding: 10
    }

    ColumnLayout {
        y: 21
        width: 257
        height: 180
        anchors.left: parent.left
        anchors.leftMargin: 50
        anchors.verticalCenter: parent.verticalCenter

        Row {
            id: rowIP
            Layout.fillWidth: true
            Layout.preferredHeight: 57
            Layout.preferredWidth: 230

            Label {
                id: label
                text: qsTr("IP: ")
                anchors.verticalCenter: parent.verticalCenter
                anchors.left: parent.left
                anchors.leftMargin: 0
            }

            TextField {
                id: textFieldIP
                text: qsTr("127.0.0.1")
                font.family: "Monospace"
                anchors.verticalCenter: parent.verticalCenter
                anchors.right: parent.right
                anchors.rightMargin: 0
            }



        }

        Row {
            id: rowPort
            Layout.fillWidth: true
            Layout.preferredHeight: 57
            Layout.preferredWidth: 230
            Label {
                id: label1
                text: qsTr("Port: ")
                anchors.left: parent.left
                anchors.verticalCenter: parent.verticalCenter
                anchors.leftMargin: 0
            }

            TextField {
                id: textFieldPort
                text: qsTr("3334")
                anchors.rightMargin: 0
                anchors.right: parent.right
                anchors.verticalCenter: parent.verticalCenter
                font.family: "Monospace"
            }
        }


        Button {
            id: btBroadcast
            text: qsTr("Broadcast")
            Layout.alignment: Qt.AlignHCenter | Qt.AlignVCenter
        }



    }

    Text {
        id: txtPort
        x: 166
        y: 60
        color: "#2fe7ed"
        text: qsTr("3334")
        font.bold: true
        font.pixelSize: 28
    }
}
