import QtQuick 2.9
import QtQuick.Controls 2.2
import conn.rerefons 1.0

ApplicationWindow {
    visible: true
    width: 640
    height: 480
    title: qsTr("Control UDP de l'ESP8266")

    BackEnd{
        id: rereFons

        onPortChanged: {
            cfgF.txtPort.text = szPort;
            console.log("Port: "+szPort);
        }
        onUdpPortStatus: {
            cfgF.txtPort.color = bUdpListening ? "green":"red";
        }
    }
    SwipeView {
        id: swipeView
        anchors.fill: parent
        currentIndex: tabBar.currentIndex

        CfgForm {
            id: cfgF
            textFieldIP.onTextChanged: {
                console.log("IP nova: "+textFieldIP.text);
                rereFons.szIP = textFieldIP.text;
            }
            textFieldPort.onTextChanged: {
                console.log("Port nou: "+textFieldPort.text-1);
                rereFons.szPort = textFieldPort.text-1;
            }
            btBroadcast.onClicked: {
//                console.log("IP: "+textFieldIP.text+" , Port: "+textFieldPort.text);
//                rereFons.szIP = textFieldIP.text;
//                rereFons.szPort = textFieldPort.text;
            }
        }

        Botons00Form {
            toggleButtonR.onCheckedChanged: {
                if(toggleButtonR.checked){
                    //console.log("Premut");
                    statusIndicatorR.active = true;
                    rereFons.bR = true;
                }else{
                    //console.log("No premut");
                    statusIndicatorR.active = false;
                    rereFons.bR = false;
                }
            }
            toggleButtonG.onCheckedChanged:{
                rereFons.bG = statusIndicatorG.active = toggleButtonG.checked;
            }
            toggleButtonB.onCheckedChanged: rereFons.bB = statusIndicatorB.active = toggleButtonB.checked;
        }       
    }

    footer: TabBar {
        id: tabBar
        currentIndex: swipeView.currentIndex

        TabButton {
            text: qsTr("Configuració")
        }
        TabButton {
            text: qsTr("ESP8266")
        }
    }
}
