#include "rerefons.h"
#include <QDebug>

RereFons::RereFons(QObject *parent) : QObject(parent)
{
    m_szIP = "127.0.0.1";
    m_szPort = QString::number(nPort = PORT_BY_DEFAULT);
    m_bR = m_bG = m_bB = m_bU = false;
    udpSocketEscoltador = NULL;
    vCanviaPort(nPort);
}

QString RereFons::szIP(){
    return m_szIP;
}

void RereFons::setIP(QString qsz){
    m_szIP = qsz;
    qDebug() << "C++ -> Ip: "<<qsz;
    emit ipChanged();
}

QString RereFons::szPort(){
    return m_szPort;
}

void RereFons::setPort(QString qsz){
    m_szPort = qsz;
    emit portChanged();
    qDebug() << "C++ -> IP: " << m_szIP << ", Port: " << m_szPort;
    nPort = m_szPort.toInt();
    //setU(qsz.toInt()%2);
    vCanviaPort(nPort);
}

bool RereFons::bR(){
    return m_bR;
}

void RereFons::setR(bool b){
    m_bR = b;
    emit rChanged();
    bSendUdpByteArray(b?"15H":"15L");
    vEstatLeds();
}

bool RereFons::bG(){
    return m_bG;
}

void RereFons::setG(bool b){
    m_bG = b;
    emit gChanged();
    bSendUdpByteArray(b?"13H":"13L");
    vEstatLeds();
}

bool RereFons::bB(){
    return m_bB;
}

void RereFons::setB(bool b){
    m_bB = b;
    emit bChanged();
    bSendUdpByteArray(b?"12H":"12L");
    vEstatLeds();
}

bool RereFons::bU(){
    return m_bU;
}

void RereFons::setU(bool b){
    m_bU = b;
    emit udpPortStatus();
}

void RereFons::vEstatLeds(){
    QString qsz = "R: ";
    qsz += (m_bR) ? "H":"L";
    qsz += ", G: ";
    qsz += m_bG?"H":"L";
    qsz += ", B: ";
    qsz += m_bB?"H":"L";

    qDebug() << qsz;
}

bool RereFons::bSendUdpByteArray(QByteArray qba){
    QUdpSocket *udpSendingSocket = new QUdpSocket(this);
    return udpSendingSocket->writeDatagram(qba,QHostAddress(m_szIP),m_szPort.toInt()+1);
}

void RereFons::vlecturaDatagramesPendents(){
    qDebug() << "Un datagrama";
    while (udpSocketEscoltador->hasPendingDatagrams()) {
        QNetworkDatagram datagram = udpSocketEscoltador->receiveDatagram();
        vProcessaDatagrama(datagram);
    }
}

void RereFons::vProcessaDatagrama(QNetworkDatagram datagram){
    QByteArray qbaDatagrama = datagram.data();

    QString qsz = "Des de " + datagram.senderAddress().toString() + ": ";
    qsz += qbaDatagrama;

    qDebug() << qsz;

//    qsz = "Des de <font color=\"red\">" + datagram.senderAddress().toString() + "</font>: ";
//    qsz += "<font color=\"blue\">" + qbaDatagrama + "</font>";
//    ui->plainTextEdit->appendHtml(qsz);
}

bool RereFons::bInitSocket(quint16 nP){
    bool bRunning;

    if(udpSocketEscoltador){
        udpSocketEscoltador->deleteLater();
        disconnect(udpSocketEscoltador);
        delete udpSocketEscoltador;
        udpSocketEscoltador = NULL;
    }
    udpSocketEscoltador = new QUdpSocket(this);
    //udpSocketEscoltador->bind(QHostAddress::LocalHost, nPort);
    bRunning = udpSocketEscoltador->bind(QHostAddress::AnyIPv4, nP);


    connect(udpSocketEscoltador, SIGNAL(readyRead()),
            this, SLOT(vlecturaDatagramesPendents()));

    return bRunning;
}

void RereFons::vCanviaPort(int nP){
    nPort = (quint16)nP;

    QString qsz;
    if(bInitSocket(nPort)){
        qsz = "Rx Port: " + QString::number(nPort);
        //ui->etInfo->setStyleSheet("QLabel { color : green; }");
        setU(true);
    }else{
        qsz = "Rx Port " + QString::number(nPort) +" ocupat";
        //ui->etInfo->setStyleSheet("QLabel { color : red; }");
        setU(false);
    }
    //ui->etInfo->setText(qsz);
    //setPort(m_szPort);
}
