#ifndef REREFONS_H
#define REREFONS_H

#include <QObject>
#include <QUdpSocket>
#include <QNetworkDatagram>

#define PORT_BY_DEFAULT 3333

class RereFons : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString szIP READ szIP WRITE setIP NOTIFY ipChanged)
    Q_PROPERTY(QString szPort READ szPort WRITE setPort NOTIFY portChanged)
    Q_PROPERTY(bool bR READ bR WRITE setR NOTIFY rChanged)
    Q_PROPERTY(bool bG READ bG WRITE setG NOTIFY gChanged)
    Q_PROPERTY(bool bB READ bB WRITE setB NOTIFY bChanged)
    Q_PROPERTY(bool bUdpListening READ bU WRITE setU NOTIFY udpPortStatus)

public:
    explicit RereFons(QObject *parent = nullptr);

    QString szIP();
    void setIP(QString);
    QString szPort();
    void setPort(QString);
    bool bR();
    void setR(bool);
    bool bG();
    void setG(bool);
    bool bB();
    void setB(bool);
    bool bU();
    void setU(bool);

    void vEstatLeds();
    bool bSendUdpByteArray(QByteArray);

signals:
    void ipChanged();
    void portChanged();
    void rChanged();
    void gChanged();
    void bChanged();
    void udpPortStatus();

public slots:
    void vlecturaDatagramesPendents();
    void vCanviaPort(int);

protected:
    bool bInitSocket(quint16 nP);
    void vProcessaDatagrama(QNetworkDatagram datagram);

private:
    QString m_szIP,m_szPort;
    bool m_bR,m_bG,m_bB,m_bU;
    QUdpSocket *udpSocketEscoltador;
    qint16 nPort;
};

#endif // REREFONS_H
